--
-- Price and Farmsiloamounts Overview Display
-- author: Blacky_BPG
-- 
-- 
-- Update to 4.2.9 27.03.2014 - simplify script functions, added more fruits, correct beef price display and merge same station names
-- 
-- 

DisplayOverview = {};
DisplayOverview.moddir=g_currentModDirectory;
DisplayOverview.modname=g_currentModName;

function DisplayOverview:loadMap(name)
	self.PriceHUDactive=false;
	self.PriceOverlay ={};
	self.PriceOverlay.OverlayId = {};
	if g_newGUISkin then
		self.PriceOverlay.OverlayId.ovidAll = createImageOverlay(Utils.getFilename("OverlayPrice2_ngs.dds", DisplayOverview.moddir));
	else
		self.PriceOverlay.OverlayId.ovidAll = createImageOverlay(Utils.getFilename("OverlayPrice2.dds", DisplayOverview.moddir));
	end;
	self.PriceOverlay.Width = 0.92;
	self.PriceOverlay.Height = 0.5525;
	self.PriceOverlay.PosX = 0.03;
	self.PriceOverlay.PosY = 0.286;
	self.resetHudTimer = 0;

	stations = {};
	fillTypes = {};

	self.maxNormPrice = 0;
	self.minNormPrice = 100;
	self.maxTrailerPrice = 0;
	self.minTrailerPrice = 100;

	self.PriceOverlay.numActives = 0;

	self.farmIdx = 0;
end;

function DisplayOverview:deleteMap()
end;

function DisplayOverview:mouseEvent(posX, posY, isDown, isUp, button)
end;

function DisplayOverview:keyEvent(unicode, sym, modifier, isDown)
end;

function DisplayOverview:draw()
      if self.PriceHUDactive and fillTypes ~= nil and table.getn(fillTypes) > 0 and stations ~= nil and table.getn(stations) > 0 then
		setTextBold(false);
		setTextColor(1,1,1,1);
		local dieselPos = 0;
		local fFontSize = 0.014;
		local fLineDist = fFontSize + 0.002;
		local PosX = 0.5 - ((table.getn(stations) + 1) * 0.035);
		local PosY = 0.5 + ((fLineDist * (self.PriceOverlay.numActives + 2)) / 2); -- Kopfzeile
		local VPosY = 0.5 + ((fLineDist * (self.PriceOverlay.numActives - 3)) / 2); -- erster Fruchteintrag
		local cor = 1.0;
		local cog = 0.8;
		local cob1 = 0.7;
		local cob2 = 0.4;
		local back = false;

		self.PriceOverlay.PosX = PosX - 0.003;
		self.PriceOverlay.Width = 1 - (self.PriceOverlay.PosX * 2) + 0.004;
		self.PriceOverlay.PosY = 1 - PosY - 0.003;
		self.PriceOverlay.Height = PosY - self.PriceOverlay.PosY + 0.003 + fLineDist;

		if self.PriceOverlay.OverlayId.ovidAll ~= nil then
			renderOverlay(self.PriceOverlay.OverlayId.ovidAll, self.PriceOverlay.PosX, self.PriceOverlay.PosY, self.PriceOverlay.Width, self.PriceOverlay.Height);
		end;

		setTextAlignment(RenderText.ALIGN_LEFT);
		setTextColor(1,1,0,1);
		renderText(PosX, PosY-fLineDist-0.003, fFontSize, g_i18n:getText("playDay")..tostring(g_currentMission.environment.currentDay));
		local difficultyMultiplier = math.max(2 * (3 - g_currentMission.missionStats.difficulty), 1);
		local rt = 0.65;
		local gt = 0.45;
		for a=1, Fillable.NUM_FILLTYPES do
			if fillTypes[a] ~= nil and fillTypes[a].active then
				local name = fillTypes[a].name;
				if name == "grass" or name == "dryGrass" or name == "grass_windrow" or name == "dryGrass_windrow" then
					name = g_i18n:getText("grass").." | "..g_i18n:getText("dryGrass_windrow");
				elseif string.find(name,"_windrow") then
					name = g_i18n:getText("wheat_windrow");
				else
					name = g_i18n:getText(name);
				end;
				setTextAlignment(RenderText.ALIGN_LEFT);
				local diff = math.floor((1 - (PosX * 2)) / 0.00505) + 1;
				local underline = "";
				for i=1,diff do
					underline = underline .. "_";
				end;
				if rt == 0.65 then
					rt = 0.45;
					gt = 0.65;
				else
					rt = 0.65;
					gt = 0.45;
				end;
				setTextColor(rt,gt,1,0.8);
				renderText(PosX, VPosY - (fLineDist * fillTypes[a].line)-0.002, fFontSize-0.0005, underline);
				if fillTypes[a].color == 1 then
					setTextColor(cor,cog,cob1,1);
				else
					setTextColor(cor,cog,cob2,1);
				end;
				renderText(PosX, VPosY - (fLineDist * fillTypes[a].line), fFontSize, name);
				setTextAlignment(RenderText.ALIGN_RIGHT);
				renderText(1 - PosX, VPosY - (fLineDist * fillTypes[a].line), fFontSize, name);
			end;
		end;
		setTextAlignment(RenderText.ALIGN_RIGHT);
		PosX = PosX + 0.035;
		for x = 1, table.getn(stations) do
			local text = g_i18n:getText(stations[x].name);
			if not g_i18n:hasText(stations[x].name) then
				text = string.gsub(stations[x].name,"Station","");
			end;
			setTextColor(1,1,0,1);
			PosX = PosX + 0.065;
			if stations[x].name == "FarmSilo" then
				if self.farmIdx > 0 then
					text = g_currentMission.ExtraFarm[self.farmIdx].farmName;
				end;
				setTextColor(0.5,1,0,1);
				cor = cog - 0.2;
				cog = 1.0;
				if g_currentMission.ExtraFarm ~= nil and table.getn(g_currentMission.ExtraFarm) > 0 then
					text = text.." ("..tostring(self.farmIdx+1).." | "..tostring(table.getn(g_currentMission.ExtraFarm)+1)..")";
				end;
				-- text = text .. " ("..tostring(self.resetHudTimer)..")";
			end;
			setTextBold(true);
			renderText(PosX, PosY, fFontSize, text);
			setTextBold(false);
			if x == 1 and g_currentMission.gasStations ~= nil then
				setTextColor(1,0.5,0.5,1);
				setTextAlignment(RenderText.ALIGN_LEFT);
				renderText(PosX+0.025, PosY-fLineDist-0.003, fFontSize, string.format(g_i18n:getText("dieselString"),tostring(self.minTrailerPrice),tostring(self.maxTrailerPrice),tostring(self.minNormPrice),tostring(self.maxNormPrice)));
				setTextAlignment(RenderText.ALIGN_RIGHT);
			end;
			for e, f in pairs(stations[x].FruitTypes) do
				if e ~= nil then
					local money =  string.format("%1.1f", ((Utils.getNoNil(stations[x].FruitTypes[e].pricePerLiter, 0.0) * Utils.getNoNil(stations[x].FruitTypes[e].priceMultiplier, 0.0) * Utils.getNoNil(stations[x].FruitTypes[e].greatDemandMultiplier, 1.0) * difficultyMultiplier)*10000)/10);
					if stations[x].FruitTypes[e].name == "pig" then
						money =  string.format("%1.1f", ((Utils.getNoNil(stations[x].FruitTypes[e].pricePerLiter, 0.0) / 1000 * Utils.getNoNil(stations[x].FruitTypes[e].priceMultiplier, 0.0) * Utils.getNoNil(stations[x].FruitTypes[e].greatDemandMultiplier, 1.0) * difficultyMultiplier)*10000)/10);
					elseif stations[x].FruitTypes[e].name == "cow" then
						money =  string.format("%1.1f", ((Utils.getNoNil(stations[x].FruitTypes[e].pricePerLiter, 0.0) / 1000 * Utils.getNoNil(stations[x].FruitTypes[e].priceMultiplier, 0.0) * Utils.getNoNil(stations[x].FruitTypes[e].greatDemandMultiplier, 1.0) * difficultyMultiplier)*10000)/10);
					elseif stations[x].FruitTypes[e].name == "beef" then
						money =  string.format("%1.1f", ((Utils.getNoNil(stations[x].FruitTypes[e].pricePerLiter, 0.0) / 1000 * Utils.getNoNil(stations[x].FruitTypes[e].priceMultiplier, 0.0) * Utils.getNoNil(stations[x].FruitTypes[e].greatDemandMultiplier, 1.0) * difficultyMultiplier)*10000)/10);
					elseif stations[x].FruitTypes[e].name == "sheep" then
						money =  string.format("%1.1f", ((Utils.getNoNil(stations[x].FruitTypes[e].pricePerLiter, 0.0) / 1000 * Utils.getNoNil(stations[x].FruitTypes[e].priceMultiplier, 0.0) * Utils.getNoNil(stations[x].FruitTypes[e].greatDemandMultiplier, 1.0) * difficultyMultiplier)*10000)/10);
					elseif stations[x].FruitTypes[e].name == "chicken" then
						money =  string.format("%1.1f", ((Utils.getNoNil(stations[x].FruitTypes[e].pricePerLiter, 0.0) / 1000 * Utils.getNoNil(stations[x].FruitTypes[e].priceMultiplier, 0.0) * Utils.getNoNil(stations[x].FruitTypes[e].greatDemandMultiplier, 1.0) * difficultyMultiplier)*10000)/10);
					end;

					cor = 1.0;
					cog = 0.8;
					cob1 = 0.7;
					cob2 = 0.4;
					back = false;

					ffT = 0;
					for kk=1, Fillable.NUM_FILLTYPES do
						if fillTypes[kk] ~= nil and fillTypes[kk].name == stations[x].FruitTypes[e].name then
							ffT = kk;
						end;
					end;
					if stations[x].name == "FarmSilo" then
						money = string.format("%1.0f", Utils.getNoNil(stations[x].FruitTypes[e].pricePerLiter, 0.0));
						cor = cog - 0.2;
						cog = 1.0;
					end;
					if stations[x].FruitTypes[e].greatDemand == true then
						back = true;
						cog = 1.0;
						cor = 0.0;
						cob1 = 1.0;
						cob2 = 1.0;
					end;
					if g_currentMission.fruitDumped ~= nil and Fillable.fillTypeIndexToDesc[g_currentMission.fruitDumped] ~= nil and stations[x].name ~= "FarmSilo" then
						if stations[x].FruitTypes[e].name == Fillable.fillTypeIndexToDesc[g_currentMission.fruitDumped].name then
							back = true;
							cog = 0.1;
							cor = 1.0;
							cob1 = 0.1;
							cob2 = 0.1;
						end;
						if stations[x].FruitTypes[e].greatDemand == true then
							back = true;
							cog = 0.1;
							cor = 1.0;
							cob1 = 1.0;
							cob2 = 1.0;
						end;
					end;
					if fillTypes[ffT] ~= nil then
						if fillTypes[ffT].color == 1 then
							setTextColor(cor,cog,cob1,1);
						else
							setTextColor(cor,cog,cob2,1);
						end;
					end;
					if fillTypes[ffT] ~= nil then
						if fillTypes[ffT].active and stations[x].FruitTypes[e].name == fillTypes[ffT].name then
							renderText(PosX, VPosY - (fLineDist * fillTypes[ffT].line), fFontSize, money);
						end;
					end;
					if back == true then
						cor = 1.0;
						cog = 0.8;
						cob1 = 0.7;
						cob2 = 0.4;
						back = false;
					end;
				end;
			end;
		end;
		setTextAlignment(RenderText.ALIGN_LEFT);
      end;
end;

function DisplayOverview:update(dt)
	if InputBinding.hasEvent(InputBinding.Price_TOGGLE_FARM) then
		if g_currentMission.ExtraFarm ~= nil and table.getn(g_currentMission.ExtraFarm) > 0 then
			if self.PriceHUDactive then
				self.farmIdx = self.farmIdx + 1;
				if self.farmIdx > table.getn(g_currentMission.ExtraFarm) then
					self.farmIdx = 0;
				end;
				self.resetHudTimer = 1;
			end;
		end;
	elseif InputBinding.hasEvent(InputBinding.Price_TOGGLE) then
		self.PriceHUDactive=not self.PriceHUDactive;
		if self.PriceHUDactive then
			self.resetHudTimer = 0;
		end;
	end;

	if self.PriceHUDactive and self.resetHudTimer <= 0 then
		self.PriceOverlay.numActives = 0;
		local lines = 0;
		local color = 1;
		local grassFix = nil;
		local strawFix = nil;
		fillTypes = nil;
		fillTypes = {};
		for a=1, Fillable.NUM_FILLTYPES do
			local desc = Fillable.fillTypeIndexToDesc[a];
			if desc ~= nil then
				local add = true;
				if (desc.name == "grass" or desc.name == "dryGrass" or desc.name == "grass_windrow" or desc.name == "dryGrass_windrow") and grassFix == nil then
					grassFix = a;
				elseif string.find(desc.name,"_windrow") and strawFix == nil then
					strawFix = a;
				elseif (desc.name == "grass" or desc.name == "dryGrass" or desc.name == "grass_windrow" or desc.name == "dryGrass_windrow") and grassFix ~= nil then
					add = false;
				elseif string.find(desc.name,"_windrow") and strawFix ~= nil then
					add = false;
				elseif desc.name == "wool" or desc.name == "fuel2" or desc.name == "repairs" or desc.name == "green" or desc.name == "egg" or desc.name == "kalkSolid" or desc.name == "manureSolid" or desc.name == "manureLiquid" or desc.name == "chaff_fix" or desc.name == "silage_fix" then
					add = false;
				elseif string.find(desc.name,"fruit_") then
					add = false;
				end;
				if add then
					fillTypes[a] = {};
					fillTypes[a].name = desc.name;
					color = color + 1;
					if color > 2 then
						color = 1;
					end;
					fillTypes[a].line = lines;
					lines = lines + 1;
					fillTypes[a].color = color;
					fillTypes[a].active = false;
				end;
			end;
		end;
		self.resetHudTimer = 33;
		self.maxNormPrice = 0;
		self.minNormPrice = 100;
		self.maxTrailerPrice = 0;
		self.minTrailerPrice = 100;
		local fuelFix = 0;
		if g_currentMission.gasStations ~= nil and table.getn(g_currentMission.gasStations) > 0 then
			for a, b in pairs(g_currentMission.gasStations) do
				if b ~= nil and b.maxFuel == -1 then
					local fuelPrice = math.floor(Fillable.fillTypeIndexToDesc[Fillable.FILLTYPE_FUEL2].pricePerLiter * b.priceMultiplier * 1000) / 1000;
					if b.trailerCan then
						if fuelPrice > self.maxTrailerPrice then
							self.maxTrailerPrice = fuelPrice;
						end;
						if fuelPrice < self.minTrailerPrice then
							self.minTrailerPrice = fuelPrice;
						end;
					end;
					if not b.trailerOnly then
						if fuelPrice > self.maxNormPrice then
							self.maxNormPrice = fuelPrice;
						end;
						if fuelPrice < self.minNormPrice then
							self.minNormPrice = fuelPrice;
						end;
					end;
				else
					if not fillTypes[Fillable.FILLTYPE_FUEL].active then
						fillTypes[Fillable.FILLTYPE_FUEL].active = true;
						self.PriceOverlay.numActives = self.PriceOverlay.numActives + 1
					end;
					if b.rootNode ~= nil then
						if b.extraSilo ~= nil then
							if b.extraSilo.farmNumber == self.farmIdx then
								fuelFix = fuelFix + b.fillLevel;
							end;
						else
							if self.farmIdx == 0 then
								fuelFix = fuelFix + b.fillLevel;
							end;
						end;
					end;
				end;
			end;
		end;
		stations = nil;
		stations = {};
		for a, b in pairs(g_currentMission.tipTriggers) do
			if b ~= nil then
				if b.isFarmTrigger == true or b.stationName == "BunkerSilo" or b.stationName == "Station" or b.appearsOnPDA ~= true then
				else
					local curPos = table.getn(stations) + 1;
					local addTo = true;
					if table.getn(stations) > 0 then
						for x = 1, table.getn(stations) do
							if stations[x].name == b.stationName then
								curPos = x;
								addTo = false;
							end;
						end;
					end;
					if addTo then
						stations[curPos] = {};
					end;
					stations[curPos].name = b.stationName;
					if stations[curPos].FruitTypes == nil then
						stations[curPos].FruitTypes = {};
					end;
					for c, d in pairs(b.acceptedFillTypes) do
						if c ~= nil and d == true then
							stations[curPos].FruitTypes[c] = {};
							stations[curPos].FruitTypes[c].name = Fillable.fillTypeIndexToDesc[c].name;
							if stations[curPos].FruitTypes[c].name == "chaff" and Fillable.fillTypeNameToDesc["chaff_fix"] ~= nil then
								stations[curPos].FruitTypes[c].pricePerLiter = Fillable.fillTypeIndexToDesc[Fillable.fillTypeNameToDesc["chaff_fix"].index].pricePerLiter;
							elseif stations[curPos].FruitTypes[c].name == "silage" and Fillable.fillTypeNameToDesc["silage_fix"] ~= nil then
								stations[curPos].FruitTypes[c].pricePerLiter = Fillable.fillTypeIndexToDesc[Fillable.fillTypeNameToDesc["silage_fix"].index].pricePerLiter;
							else
								stations[curPos].FruitTypes[c].pricePerLiter = Fillable.fillTypeIndexToDesc[c].pricePerLiter;
							end;
							stations[curPos].FruitTypes[c].priceMultiplier = b.priceMultipliers[c];
							stations[curPos].FruitTypes[c].greatDemandMultiplier = 1;
							stations[curPos].FruitTypes[c].greatDemand = false;
							local greatDemand = g_currentMission.economyManager:getCurrentGreatDemand(b.stationName, c);
							if greatDemand ~= nil then
								stations[curPos].FruitTypes[c].greatDemandMultiplier = greatDemand.demandMultiplier;
								stations[curPos].FruitTypes[c].greatDemand = true;
							end;
							if fillTypes[c] ~= nil and not fillTypes[c].active then
								fillTypes[c].active = true;
								self.PriceOverlay.numActives = self.PriceOverlay.numActives + 1;
							end;
						end;
					end;
				end;
			end;
		end;
		local data = {};
		data.name = "FarmSilo";
		data.FruitTypes = {};
		local strawId = nil;
		local grassId = nil;
		for a=1, Fillable.NUM_FILLTYPES do
			local FruitType = {};
			local desc = Fillable.fillTypeIndexToDesc[a];
			if desc ~= nil then
				FruitType.name = desc.name;
				if a ~= Fillable.FILLTYPE_FUEL then
					if Fillable.FILLTYPE_PIG ~= nil and a == Fillable.FILLTYPE_PIG and g_currentMission.husbandries ~= nil and g_currentMission.husbandries.pig ~= nil and g_currentMission.husbandries.pig.numSchweine ~= nil then
						FruitType.pricePerLiter = Utils.getNoNil(g_currentMission.husbandries.pig.numSchweine,0);
					elseif Fillable.FILLTYPE_BEEF ~= nil and a == Fillable.FILLTYPE_BEEF and g_currentMission.husbandries ~= nil and g_currentMission.husbandries.beef ~= nil and g_currentMission.husbandries.beef.numSchweine ~= nil then
						FruitType.pricePerLiter = Utils.getNoNil(g_currentMission.husbandries.beef.numSchweine,0);
					elseif Fillable.FILLTYPE_COW ~= nil and a == Fillable.FILLTYPE_COW and g_currentMission.husbandries ~= nil and g_currentMission.husbandries.cow ~= nil and g_currentMission.husbandries.cow.totalNumAnimals ~= nil then
						FruitType.pricePerLiter = g_currentMission.husbandries.cow.totalNumAnimals;
					elseif Fillable.FILLTYPE_SHEEP ~= nil and a == Fillable.FILLTYPE_SHEEP and g_currentMission.husbandries ~= nil and g_currentMission.husbandries.sheep ~= nil and g_currentMission.husbandries.sheep.totalNumAnimals ~= nil then
						FruitType.pricePerLiter = g_currentMission.husbandries.sheep.totalNumAnimals;
					elseif Fillable.FILLTYPE_CHICKEN ~= nil and a == Fillable.FILLTYPE_CHICKEN and g_currentMission.husbandries ~= nil and g_currentMission.husbandries.chicken ~= nil and g_currentMission.husbandries.chicken.totalNumAnimals ~= nil then
						FruitType.pricePerLiter = g_currentMission.husbandries.chicken.totalNumAnimals;
					elseif self.farmIdx > 0 then
						local amount = g_currentMission.ExtraFarm[self.farmIdx]:getSiloAmount(a,self.farmIdx);
						local allowed = g_currentMission.ExtraFarm[self.farmIdx]:getUnloadAmount(a,self.farmIdx);
						if allowed > 0 or amount > 0 then
							FruitType.pricePerLiter = amount;
						end;
					else
						if FruitType.name == "manure" then
							FruitType.pricePerLiter = Utils.getNoNil(tonumber(g_currentMission.husbandries.cow:getFluidStatsText(g_currentMission.husbandries.cow.manureHeap.fillLevel)), 0) + Utils.getNoNil(g_currentMission:getSiloAmount(Fillable.FILLTYPE_MANURE),0);
							if g_currentMission.husbandries.beef ~= nil and g_currentMission.husbandries.beef.manureHeap ~= nil then
								FruitType.pricePerLiter = FruitType.pricePerLiter + Utils.getNoNil(g_currentMission.husbandries.beef.manureHeap.FillLvl,0);
							end;
							if g_currentMission.husbandries.pig ~= nil and g_currentMission.husbandries.pig.manureHeap ~= nil then
								FruitType.pricePerLiter = FruitType.pricePerLiter + Utils.getNoNil(g_currentMission.husbandries.pig.manureHeap.FillLvl,0);
							end;
						elseif FruitType.name == "liquidManure" then
							FruitType.pricePerLiter = Utils.getNoNil(tonumber(g_currentMission.husbandries.cow:getFluidStatsText(g_currentMission.husbandries.cow.liquidManureTrigger.fillLevel)), 0) + Utils.getNoNil(g_currentMission:getSiloAmount(Fillable.FILLTYPE_LIQUIDMANURE),0);
							if g_currentMission.husbandries.beef ~= nil and g_currentMission.husbandries.beef.liquidManureSiloTrigger ~= nil then
								FruitType.pricePerLiter = FruitType.pricePerLiter + Utils.getNoNil(g_currentMission.husbandries.beef.liquidManureSiloTrigger.fillLevel,0);
							end;
							if g_currentMission.husbandries.pig ~= nil and g_currentMission.husbandries.pig.liquidManureSiloTrigger ~= nil then
								FruitType.pricePerLiter = FruitType.pricePerLiter + Utils.getNoNil(g_currentMission.husbandries.pig.liquidManureSiloTrigger.fillLevel,0);
							end;
						elseif FruitType.name == "milk" then
							FruitType.pricePerLiter = Utils.getNoNil(tonumber(g_currentMission.husbandries.cow:getFluidStatsText(g_currentMission.husbandries.cow.fillLevelMilk)), 0) + Utils.getNoNil(g_currentMission:getSiloAmount(Fillable.FILLTYPE_MILK),0);
						else
							FruitType.pricePerLiter = g_currentMission:getSiloAmount(a);
						end;
					end;
				else
					if self.farmIdx > 0 then
						local amount = g_currentMission.ExtraFarm[self.farmIdx]:getSiloAmount(a,self.farmIdx);
						local allowed = g_currentMission.ExtraFarm[self.farmIdx]:getUnloadAmount(a,self.farmIdx);
						if allowed > 0 or (amount > 0 and allowed == 0) then
							FruitType.pricePerLiter = amount;
						end;
						FruitType.pricePerLiter = fuelFix + Utils.getNoNil(FruitType.pricePerLiter,0);
					else
						FruitType.pricePerLiter = fuelFix + g_currentMission:getSiloAmount(Fillable.FILLTYPE_FUEL);
					end;
				end;
				if FruitType.pricePerLiter ~= nil then
					FruitType.priceMultiplier = 1;
					if desc.name == "grass_windrow" or desc.name == "dryGrass_windrow" or desc.name == "grass" or desc.name == "dryGrass" then
						if grassId == nil then
							if not fillTypes[a].active then
								fillTypes[a].active = true;
								self.PriceOverlay.numActives = self.PriceOverlay.numActives + 1;
							end;
							table.insert(data.FruitTypes,FruitType);
							grassId = table.getn(data.FruitTypes);
						else
							data.FruitTypes[grassId].pricePerLiter = data.FruitTypes[grassId].pricePerLiter + FruitType.pricePerLiter;
						end;
					else
						if string.find(desc.name,"_windrow") and strawId == nil then
							if not fillTypes[a].active then
								fillTypes[a].active = true;
								self.PriceOverlay.numActives = self.PriceOverlay.numActives + 1
							end;
							table.insert(data.FruitTypes,FruitType);
							strawId = table.getn(data.FruitTypes);
						elseif string.find(desc.name,"_windrow") and strawId ~= nil then
							data.FruitTypes[strawId].pricePerLiter = data.FruitTypes[strawId].pricePerLiter + FruitType.pricePerLiter;
						else
							if desc.name ~= "wool" and desc.name ~= "fuel2" and desc.name ~= "repairs" and desc.name ~= "green" and desc.name ~= "egg" and desc.name ~= "kalkSolid" and desc.name ~= "manureSolid" and desc.name ~= "manureLiquid" and desc.name ~= "chaff_fix" and desc.name ~= "silage_fix" then
								if fillTypes[a] ~= nil and not fillTypes[a].active then
									fillTypes[a].active = true;
									self.PriceOverlay.numActives = self.PriceOverlay.numActives + 1;
								end;
							end;
							table.insert(data.FruitTypes,FruitType);
						end;
					end;
				end;
			end;
		end;
		table.insert(stations,data);
      else
		if self.PriceHUDactive then
			self.resetHudTimer = self.resetHudTimer - 1;
		end;
      end;
end;

addModEventListener(DisplayOverview);

